generic/405: test mkfs against thin provision device
[xfstests-dev.git] / tests / generic / 075
1 #! /bin/bash
2 # FS QA Test No. 075
3 #
4 # fsx (non-AIO variant)
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2003 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=0        # success is the default!
32 trap "_cleanup; exit \$status" 0 1 2 3 15
33
34 _cleanup()
35 {
36     cd /
37     rm -rf $TEST_DIR/fsx.* $tmp.*
38 }
39
40 # get standard environment, filters and checks
41 . ./common/rc
42 . ./common/filter
43
44 _do_test()
45 {
46     _n="$1"
47     _param="$2"
48
49     out=$TEST_DIR/fsx
50     rm -rf $out
51     if ! mkdir $out
52     then
53         echo "    failed to mkdir $out"
54         status=1
55         exit
56     fi
57
58     _filter_param=`echo "$_param" | sed\
59         -e 's/-N [0-9][0-9]*/-N numops/' \
60         -e 's/-l [0-9][0-9]*/-l filelen/'`
61
62     echo ""
63     echo "-----------------------------------------------"
64     echo "fsx.$_n : $_filter_param"
65     echo "-----------------------------------------------"
66
67     if [ "$FSTYP" != "xfs" ]
68     then
69         if [ "$_n" = "1" -o "$_n" = "3" ]
70         then
71             # HACK: only xfs handles preallocation (-x) so just skip this test
72             return
73         fi
74     fi
75
76     # This cd and use of -P gets full debug on $here (not TEST_DEV)
77     cd $out
78     if ! $here/ltp/fsx $_param -P $here $seq.$_n $FSX_AVOID &>/dev/null
79     then
80         echo "    fsx ($_param) failed, $? - compare $seqres.$_n.{good,bad,fsxlog}"
81         mv $out/$seq.$_n $seqres.$_n.full
82         mv $here/$seq.$_n.fsxlog $seqres.$_n.fsxlog
83         od -xAx $seqres.$_n.full > $seqres.$_n.bad
84         od -xAx $here/$seq.$_n.fsxgood > $seqres.$_n.good
85         rm -f $here/$seq.$_n.fsxgood
86         status=1
87         exit
88     fi
89
90     cd $here
91     _check_test_fs
92 }
93
94 _usage()
95 {
96     echo "$0: [-l filelen] [-n numops1] [-N numops2]"
97 }
98
99 _process_args()
100 {
101     while getopts "l:n:N:?" c $@
102     do
103         case $c
104         in
105             l)
106                 filelen=$OPTARG
107                 param_type="$param_type, overidde -l"
108                 ;;
109             N)
110                 numops2=$OPTARG
111                 param_type="$param_type, overidde -N"
112                 ;;
113             n)
114                 numops1=$OPTARG
115                 param_type="$param_type, overidde -n"
116                 ;;
117             ?)
118                 _usage
119                 exit    
120                 ;;
121         esac
122     done
123 }
124
125 # real QA test starts here
126 _supported_fs generic
127 _supported_os IRIX Linux
128 _require_test
129
130 size10=`expr 10 \* 1024 \* 1024`        # 10 megabytes
131 filelen=$size10
132 numops1=1000
133 numops2=10000
134
135 # can override the params here
136 _process_args "$@"
137
138 echo "Params are for $param_type" >>$seqres.full
139 echo "Params: n = $numops1 N = $numops2 l = $filelen" >>$seqres.full
140
141 rm -f $seqres.full
142 echo "brevity is wit..."
143
144 _check_test_fs
145
146 # Options:
147 # -d: debug output for all operations
148 # -l flen: the upper bound on file size (default 262144)
149 # -o oplen: the upper bound on operation size
150 # -N numops: total # operations to do (default infinity)
151 # -P: save .fsxlog and .fsxgood files in dirpath (default ./)
152 # -S seed: for random # generator (default 1) 0 gets timestamp
153 # -x: pre-allocate file space, exercising unwritten extents
154
155 _do_test 0 "-d -N $numops1 -S 0"
156 _do_test 1 "-d -N $numops1 -S 0 -x"
157 _do_test 2 "-d -N $numops2 -l $filelen -S 0"
158 _do_test 3 "-d -N $numops2 -l $filelen -S 0 -x"
159
160 rm -f $seq.*.fsx{good,log}
161 exit 0